#include "mcsubs.h" 
#include "mclm.h" 
#include "gammas.h" 
#include "tlest.h" 
#include "qsubs.h" 

extern int qtmode ;
extern int lmmodel ;
extern int lmchrom ;
extern int markernum ;
extern int numsnps ;

extern int packmode ;  
extern char *packgenos ;
extern char *packepath ;
extern int packlen, rlen ;

extern int rdismode ;
extern double rdis ;
extern double loclip, hiclip ;

int monitlo = -1, monithi = -1 ;

double xranbeta(double a, double b, double lo, double hi) ;

double clocktime() ;

double 
ranpath(int indiv, SNP **snpmarkers, int *ethnic, 
 int fc, int lc, double **betas) ;


void print3(double *tt) ;

double mufun1(double x) ;

double 
domc1(double *totscore, double *zstat, SNP **snpmarkers, SNPMC **snpmcmarkers, 
 int numsnps, int numindivs, 
 double *riskarr, double *risk2arr, double *criskarr, 
 double *modelsc,  double *wriskx, 
 int numrisks, 
 double *tave, double *lave, double *xtave, double *xlave,
 int pubxindiv, double **pubgams) 
{
    int *ethnic ;
    Indiv *indx ;
    int indiv, numstates, irisk ; 
    double xtheta, theta, lambda ; 
    double y, y2, tmp, ynumx  ;
    double t0[3], ss[3], psi[3], gg[3], ww[3], g2[3], ee[3] ;
    double ggr[3] ;  // for isrfake "gammas" 
    double gtot[3] ;
    double dd[4] ;
    SNP *cupt, *tcupt ;
    SNPMC *cumcpt ;
    double **betas ;
    double **alphas ;
    double logfac = 0.0 ;
    double s1, s2, score, scbug, *totbug ;
    double tbug = 0.0, ts1, ts2, ttscore, tbmax = -999999.0 ;
    int ktmax ;
    int vmode ;
    int crisk = NO ;

    int fc, lc, chrom, i, a, g, k, j, ghalf, t ;
    static int monitindiv = -1 ;
    
    double time0, time1 ;
    double scalpha, scbeta ;
    double frisk[MAXNUMR], *wrisk ;
    double *modelspt ;

    double **srisks ;  /* riskmodel x marker */
    double *qscore = NULL ;

    static int ncall=0; 
    int ignore ;
    double tsum, lsum , xtsum[2], xlsum[2] ;
    int numind, xnumind[2] ;
    int ncase, ncontrol ;
    double *z1case, *z1control, *z2case, *z2control, *w1, *w2 ;
    double *wscore, *ifake ;
    double zmax, zmin, qtot ;
    int eaddress ;
    double tentrop[24], *rentrop, tscore ;


/** make log score  */
    srisks = initarray_2Ddouble(numrisks, numsnps, 0.0) ;
    if (qtmode) ZALLOC(qscore, numrisks, double) ;

    ++ncall ;
    ZALLOC(wrisk, numrisks, double) ;
    if (wriskx == NULL) {
     vclear(wrisk, 1.0, numrisks) ; /* weighting */ 
    }
    else { 
     copyarr(wriskx, wrisk, numrisks) ;
    }
    tsum = lsum = 0.0 ;
    vzero(xtsum,2) ;
    vzero(xlsum,2) ;
    vzero(gtot, 3) ;
    numind = 0 ;
    ivzero(xnumind, 2) ;
    time0 = clocktime() ;
/* wipe out (state, g) counts */
  for (i=0; i<numsnps; i++)  {  
     cupt = snpmarkers[i] ;
     if ((cupt -> isfake) && (!(cupt -> isrfake))) continue ;
     cumcpt = snpmcmarkers[i] ;
     vzero(cumcpt -> xd, 4) ;
     vzero(cumcpt -> xc, 9) ;
  }

  clearestdis(snpmarkers, numsnps) ;
  ZALLOC(ethnic, numsnps, int) ;

  eaddress = (int) ethnic ;  
/**
   printf("zzleak  %x %d\n", ethnic, eaddress) ;
*/

  vclear(totscore, -1000.0, numsnps) ;
  vzero(zstat, numsnps) ;

  ZALLOC(z1case, numsnps, double) ;
  ZALLOC(z1control, numsnps, double) ;
  ZALLOC(z2case, numsnps, double) ;
  ZALLOC(z2control, numsnps, double) ;
  ZALLOC(w1, numsnps, double) ;
  ZALLOC(w2, numsnps, double) ;
  ZALLOC(rentrop, numsnps, double) ;
  vzero(tentrop, 24) ;

  

  ncase = ncontrol = 0 ;

  betas = initarray_2Ddouble(numsnps, 3, 1.0);
  alphas = initarray_2Ddouble(numsnps, 3, 0.0);
  
  qtot = 0 ;
  if (lmmodel) clearmodelscores(snpmarkers, numsnps, NO) ; 
  for (indiv = 0; indiv < numindivs; ++indiv ) {
   ivclear(ethnic, -1, numsnps) ;
   indx = indivmarkers[indiv] ;
   vzero(w1,  numsnps) ;
   xtheta = indx->Xtheta_mode ;
/* xtheta just used for Bridge sampler */  

   for (chrom = 1; chrom <= 23 ; ++chrom) {
    fc = fchrom[chrom] ;  lc = lchrom[chrom] ;
    if (lc < 0) continue ;
    if (indiv==0) vzero(totscore+fc, lc-fc+1) ;

    cupt = snpmarkers[fc] ;
    gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;
    if (ignore == YES) continue ;

    if (chrom==1) {
     ++numind ;
     tsum += theta ;
     lsum += lambda ;
    }
    if (chrom==23) {
     k = 1 ; 
     if (indx -> gender == 'M')  k= 0;
     ++xnumind[k] ;
     xtsum[k] += theta ;
     xlsum[k] += lambda ;
    }

    t0[2] = ss[2] = 0.0 ;
    sett1(t0, theta, numstates) ;
    tentrop[chrom] += entrop(t0, numstates) ;


    scbeta = HMMbeta(snpmarkers,indiv, theta, lambda, fc, lc,   
     betas, NULL, numstates, NULL) ;

    scalpha  = HMMalpha(snpmarkers,indiv, theta, lambda, fc, lc,   
     alphas, NULL, numstates, NULL) ;

    logfac += 
     ranpath(indiv, snpmarkers, ethnic, fc, lc, betas) ;

     if (rdismode) putepath(snpmarkers, ethnic, fc, lc, indiv) ;

    ee[0] = 0; ee[1] = 1; ee[2] = 2 ;
    ynumx = (double) numstates -1 ;

    for (i=fc; i<=lc; i++)  {  
     j = i-fc ;
      gg[2] = 0.0 ;
      vvt(gg, alphas[j], betas[j], numstates) ;
      y = asum(gg, numstates) ;
      vst(gg, gg, 1.0/y, numstates) ;
      if ((indiv == pubxindiv) && (pubgams != NULL)) { 
       copyarr(gg, pubgams[i], 3) ;
      }
      rentrop[i] += entrop(gg, numstates) ;

      if ((i==markernum) && (y>0.0)) {
        vvp(indx -> totgamms, indx -> totgamms, gg, 3) ;
      }

/** 
 gammasum, gammanum just used for output 
 frequency file 
 We will output "average" gamma at each marker 
*/
      cumcpt = snpmcmarkers[i] ;
//    accumulate gammas for cases/controls
      if (indx->affstatus){
        k = 0 ; 
      }
      else { 
       k = 1 ;  
      }
      cumcpt->gammanum[k] += (double) (numstates-1) ; 
      cumcpt->gammasum[k] += (gg[1]+2.0*gg[2]) ; 

      totscore[i] += muval1*(xtheta-tmumean)/log(10.0) ;
/** 
 this is the bridge sampler if muval1 is nonzero 
*/
      tscore = 0.0 ; 
      if (qtmode) {  
        vmode = NO ;
        if ((i==0) && (indiv<10)) vmode = YES ; 
        if (chrom<23) 
         setqscores(indx, gg, qscore) ;
        else 
         vzero(qscore,numrisks) ; /* X not programmed yet */
        for (irisk =0 ; irisk < numrisks; ++irisk) {
         score = qscore[irisk] ;
         srisks[irisk][i] += score ;
         if (i==markernum) { 
          y = pow10(score) ; 
          tscore += wrisk[irisk]*y ;   
         } 
        }
      }

      for (irisk = 0 ; irisk < numrisks; ++irisk) {
       if (qtmode) break ;
       if (indx ->  affstatus)  {
        y = riskarr[irisk] ;
        y2 = risk2arr[irisk] ;
       }
       else { 
        y = criskarr[irisk] ;
        if (fabs(y-1.0)>0.001) crisk = YES ;
        y2 = y*y ;
       }
       psi[0] = 1.0 ; 
       psi[1] = y ; 
       psi[2] = y2 ; 
       if (fabs(y-1.0) < .0001) continue ;
       s1 = log10(vdot(psi, gg, numstates)) ;
       s2 = log10(vdot(psi, t0, numstates)) ;
       score = s1-s2 ;
       srisks[irisk][i] += score ;
       if (i==markernum) { 
        y = pow10(score) ; 
        tscore += wrisk[irisk]*y ;   
       } 
      }

      if ((i==markernum) && ((indx -> affstatus)) || (crisk==YES)) { 
        indx -> totscore  += tscore/asum(wrisk, numrisks) ; 
      }       


      cupt = snpmarkers[i] ;
      if ((lmmodel) && (cupt -> isfake == NO) && (cupt -> isrfake == NO)) { 
	if ((i==markernum) &&(indiv<-999)) {   
        printf("zzbug2 %d\n", indiv) ; 
        printmat(gg, 1, 3) ; 
        printf("zzfr: %d %9.3f %9.3f\n", indiv, 
         cupt -> adm_PopA_freq, cupt -> adm_PopB_freq) ;
	printf("zzfr2: %d %9.3f %9.3f\n", indiv, 
         cupt -> PopA_freq, cupt -> PopB_freq) ; 
	} 
       calclm(cupt, indx, gg, psi) ; 
      } 
     
      if ((lmmodel) && (cupt -> isrfake == YES)) { 
       calcY(snpmarkers, indiv, i, ggr, numstates) ;  

       if ((i==markernum) &&(indiv<-999)) {   
        printf("zzbug1 %d\n", indiv) ; 
        printmat(gg, 1, 3) ; 
        printmat(ggr, 1, 3) ; 
        printf("zzfr: %d %9.3f %9.3f\n", indiv,  
         cupt -> adm_PopA_freq, cupt -> adm_PopB_freq) ;
	printf("zzfr2: %d %9.3f %9.3f\n", indiv, 
         cupt -> PopA_freq, cupt -> PopB_freq) ;
       } 

       vvt(ggr, gg, ggr, 3) ; 
       bal1(ggr, 3) ; 
//  ggr[2] = 0 if numstates = 2
       calclm(cupt, indx, ggr, psi) ; 
       a = randis(ggr, 3) ; 
       g = -1 ; 
       if (cupt -> ngtypes >0) { 
        g = getgtypes(cupt, indiv) ;
       } 
       cumcpt = snpmcmarkers[i] ; 
       if (numstates==3) {    
         if (g>=0) { 
          t = 3*a +g ; 
          cumcpt -> xc [t]  += 1 ; 
         } 
       } 
       if (numstates==2) {    
         if (g >= 0) { 
          g = g/2 ; 
          t = 2*a +g ; 
          cumcpt -> xd [t]  += 1 ; 
         } 
       } 
      } 
      
     tmp = vdot(gg, ee, numstates) / ynumx  ; 
     tmp -= theta ; 
 
     w1[i] = tmp ; 


    }

/** 
 now accumulate (a,g) counts 
*/

    for (i=fc; i<= lc; i++)  {  
     tcupt = snpmarkers[i] ;
     if (tcupt -> ignore) continue ;
     if (tcupt -> isrfake) continue ; 
     if (tcupt -> isfake)  continue ; 
     a = ethnic[i] ;
     if (a<0) continue ;
     g = getgtypes(snpmarkers[i] , indiv)  ;
     if (g<0) continue ;
     
     cumcpt = snpmcmarkers[i] ;
     if (numstates==3)  {
      t = 3*a +g ;
      cumcpt -> xc [t]  += 1 ;
     }
     if (numstates==2) {
      ghalf = g/2 ;
      cumcpt -> xd [2*a + ghalf] += 1  ;
     }
    }
   }

   if (indx -> ignore) continue ;
   vvt(w2, w1, w1, numsnps) ;

   if (indx -> affstatus)  {  
    vvp(z1case, z1case, w1, numsnps) ;
    vvp(z2case, z2case, w2, numsnps) ;
    ++ncase ;
   }
   else {
    vvp(z1control, z1control, w1, numsnps) ;
    vvp(z2control, z2control, w2, numsnps) ;
    ++ncontrol ;
   }

    if (tlreest == YES) {  

     ivmaxmin(fchrom, 22, NULL, &fc) ;
     ivmaxmin(lchrom, 22, &lc, NULL) ;

     if ((fc>99999) || (lc<0))
      fatalx("no data\n") ;

     cupt = snpmarkers[fc] ;
     gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;
     tlest(indx, snpmarkers, ethnic, fc, lc, 
       &theta, &lambda) ;
     puttln(cupt, indx, theta, lambda) ;

/** now do X reestimates */

     fc = fchrom[23] ;  
     lc = lchrom[23] ;  

     if ((fc>=0) && (lc>=0)) {  
      cupt = snpmarkers[fc] ;
      gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;
      tlest(indx, snpmarkers, ethnic, fc, lc, 
       &theta, &lambda) ;
      puttln(cupt, indx, theta, lambda) ;
     }
    }
  }

  reestdis(snpmarkers,  numsnps, indivmarkers, numindivs,  rdis)  ;
  reestld(snpmarkers,  numsnps, indivmarkers, numindivs,  rdis)  ;
/* these are  no-ops unless rdismode set */

  time1 = clocktime() ;
  if (ncall <= 2) 
   printf("domcm1 time: %9.3f\n", time1-time0) ;

  for (i=0; i<numsnps; i++) {  
   chrom = snpmarkers[i] -> chrom ;
   y = rentrop[i]/tentrop[chrom] ;
   cumcpt = snpmcmarkers[i] ;
   cumcpt -> rpowersum += (1.0-y) ;
  }

  free2D(&alphas, numsnps) ;
  free2D(&betas, numsnps) ;

  numind = MAX(1, numind) ;
  xnumind[0] = MAX(1, xnumind[0]) ;
  xnumind[1] = MAX(1, xnumind[1]) ;
  tsum /= (double) numind ;
  lsum /= (double) numind ;
  *tave = tsum ;
  *lave = lsum ;
  xtsum[0] /= (double) xnumind[0];
  xlsum[0] /= (double) xnumind[0] ;
  xtsum[1] /= (double) xnumind[1];
  xlsum[1] /= (double) xnumind[1] ;
  copyarr(xtsum, xtave, 2) ;
  copyarr(xlsum, xlave, 2) ;

/** carry out a t-test */
  if ( (ncase >0 ) && (ncontrol > 0)) {  
   vst(z1case, z1case, 1.0/ncase, numsnps) ;
   vst(z2case, z2case, 1.0/ncase, numsnps) ;
   vvt(w2, z1case, z1case, numsnps) ;
   vvm(z2case, z2case, w2, numsnps) ;
   vst(z1control, z1control, 1.0/ncontrol, numsnps) ;
   vst(z2control, z2control, 1.0/ncontrol, numsnps) ;
   vvt(w2, z1control, z1control, numsnps) ;
   vvm(z2control, z2control, w2, numsnps) ;
   vvm(w1, z1case, z1control, numsnps) ; /* diff (mean)  */

   vst(z2case, z2case, 1.0/ncase, numsnps) ;
   vst(z2control, z2control, 1.0/ncontrol, numsnps) ;
   vvp(w2, z2case, z2control, numsnps) ;
   vsp(w2, w2, 1.0e-10, numsnps) ;

   vsqrt(w2, w2, numsnps) ;
   vvd(zstat, w1, w2, numsnps) ;

/**
   vmaxmin(zstat, numsnps, &zmax, &zmin)  ;  
   printf("zmaxmin:  %9.3f %9.3f\n", zmax, zmin) ;
*/
  }

  free(rentrop) ;
  free(w2) ;
  free(w1) ;
  free(z2control) ;
  free(z2case) ;
  free(z1control) ;
  free(z1case) ;
  free(ethnic) ;
  if (qscore != NULL) free(qscore) ;

  y = asum(wrisk, numrisks) ;
  vst(wrisk, wrisk, 1.0/y, numrisks) ;  /* weights sum to 1 */
  ZALLOC(wscore, numsnps, double) ;
  ZALLOC(ifake, numsnps, double) ;
  for (i=0; i<numsnps; i++) {
   if (snpmarkers[i] -> isfake) ifake[i] = 1 ;
   if (snpmarkers[i] -> isrfake) ifake[i] = 0 ;
// ifake flags markers to use for scoring
  }

  y = asum(ifake, numsnps) ;
  vst(ifake, ifake, 1.0/y, numsnps) ;

  for (irisk = 0; irisk < numrisks; irisk++)  {  
   vclip(srisks[irisk], srisks[irisk], loclip, hiclip, numsnps) ;

   vpow10(srisks[irisk], srisks[irisk], numsnps) ;

    for (i=0; i<numsnps; i++) {
     modelspt = snpmarkers[i] -> modelscores ;
     if (lmmodel) modelspt = NULL ;
     if (modelspt != NULL) { 
       modelspt[irisk] = srisks[irisk] [i] ;
     }
    }

   frisk[irisk] = vdot(srisks[irisk], ifake, numsnps) ;
   vst(srisks[irisk], srisks[irisk], wrisk[irisk], numsnps) ;
   vvp(wscore, wscore, srisks[irisk], numsnps) ;
  }

  vlog10(modelsc, frisk, numrisks) ;

/* fac.  average */
  vlog10(wscore, wscore, numsnps) ;
  vvp(totscore, totscore, wscore, numsnps) ;

  free(ifake) ;
  free(wscore) ;
  free2D(&srisks, numrisks) ;
  free(wrisk);

  return logfac ;
}

/* end of main routine */

void print3(double *tt) 
{

 double ww[3], y ;

 y = asum(tt, 3) ;

 if (y<0.0) y = 1.0 ;

 vst(ww, tt, 1.0/y, 3) ;

 printf(" %12.6f %12.6f %12.6f    %12.6f\n", ww[0], ww[1], ww[2],y ) ;

}

double clocktime() 
{
  double xtime ; 
  double y ;

  xtime = (double) clock() ;
  y =  xtime / (double) CLOCKS_PER_SEC ;
  return y ;
}

double 
ranpath(int indiv, SNP **snpmarkers, int *ethnic, 
 int fc, int lc, double **betas) 

{

 int len, count ;
 SNP *cupt ;
 Indiv *indx ;
 double X[3], bb[3] , cc[3],  y ;
 int i, j, k, l; 
 double **M ;
 double lfac[3],  logfac ;
 double ttt[3], yy ;
 double glen, poisson, temp ;
 double theta, lambda ;
 int numstates ;
 int estate, oldestate ;
 int debugg = NO ;
 int ignore ;

 cupt = snpmarkers[fc] ;
 indx = indivmarkers[indiv] ;
 gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;

  count = len = lc -fc +1 ;
  ivclear(ethnic +fc, -1, len) ;
  if (ignore == YES) return 0.0 ;
  sett1(ttt, theta, numstates) ;
  M = initarray_2Ddouble(3, 3, 0.0);


  estate = randis(ttt, numstates) ;
/* actually estate is irrelevant but this is careful */

  logfac = 0.0 ;

  for (j=fc; j <= lc; ++j) {  

    count = j-fc ;
    oldestate = estate ;
    poisson = 0.0 ;
    calcX(snpmarkers, indiv, j, X, numstates) ; 
    if (j>fc) {
     glen = (snpmarkers[j] -> genpos) - (snpmarkers[j-1] -> genpos);
/* this is in morgans */ 
     temp = lambda * glen ;
     if (temp<20.0) {
      poisson = exp(-temp) ;
     }
     if (lambda>500) poisson = 0.0 ;
    }

    calcM(poisson, theta, M, numstates);
/** 
  tricky.  when j==fc we have prob no recomb = 0 
*/
     for (k=0; k<numstates; k++)  {  
      cc[k] = M[k][oldestate]*betas[count][k]*X[k] ;
     }
     y = asum(cc, numstates) ;
     vst(bb, cc, 1.0/y, numstates) ;
     ethnic[j] = estate = randis(bb, numstates) ;
     logfac = logfac + log(M[estate][oldestate] * X[estate]) ;
   }
  for (i=0; i<3; i++) {
   free(M[i]) ;
  }
  free(M) ;
  return logfac ;
}


void
mk2from2(double *xd, double *xc) 
{
   double tt[4] ;
   testnan(xc,4) ;
   tt[0] = xc[1] ;
   tt[1] = xc[0] ;
   tt[2] = xc[3] ;
   tt[3] = xc[2] ;
   copyarr(tt, xd, 4) ;
}
double
mk2from3(double *xd, double *xc, double p, double pp) 
{
   double q, qq  ;
   double p1, p2 ;
   double y, ylike  ;

   int  c, c1, c2 ;
   int  e1, e2, b1, b2, n1, n2 ;
   int  k, t ;
   double a, aa, b, bb ;

   q = 1-p ; qq = 1-pp ;


   vzero(xd, 4) ;
   ylike = 0 ;
   
   for (k=0; k<9; k++)  {  
     if (xc[k]< .0001) continue ;
     e1 = e2 = b1 = b2 = n1 = n2 = 0 ;
    switch (k)  {  
     case 0:  
       e1 = 0 ; b1 = 1; n1 = 2;  
       y = q*q ;
       break ;
     case 1:  
       e1 = 0 ; b1 = 0; n1 = 1;  
       e2 = 0 ; b2 = 1; n2 = 1;  
       y = 2*q*p ;
       break ;
     case 2:  
       e1 = 0 ; b1 = 0; n1 = 2;  
       y = p*p ;
       break ;
     case 3:  
       e1 = 0 ; b1 = 1; n1 = 1;  
       e2 = 1 ; b2 = 1; n2 = 1;  
       y = q*qq ;  
       break ;
     case 4:  
       y = p*qq + pp*q ;  
       break ;
     case 5:  
       e1 = 0 ; b1 = 0; n1 = 1;  
       e2 = 1 ; b2 = 0; n2 = 1;  
       y = p*pp ;  
       break ;
     case 6:  
       e1 = 1 ; b1 = 1; n1 = 2;  
       y = qq*qq;
       break ;
     case 7:  
       e1 = 1 ; b1 = 0; n1 = 1;  
       e2 = 1 ; b2 = 1; n2 = 1;  
       y = 2*qq*pp ;
       break ;
     case 8:  
       e1 = 1 ; b1 = 0; n1 = 2;  
       y = pp*pp ;
       break ;
    }
    ylike += xc[k]*log(y) ;
    t = 2*e1 + b1 ;  xd[t] += (double) n1*xc[k] ;
    t = 2*e2 + b2 ;  xd[t] += (double) n2*xc[k] ;
   }

/* now do case 4 (need tiny MCMC here */
   p1 = p*qq ; p2 = pp*q ;  
   c =  nnint(xc[4]) ;  

   c1 = ranbinom(c, p1/(p1+p2)) ;
   c2 = c - c1 ;

   e1 = 0; b1=0; n1 = c1 ;
   e2 = 1; b2=1; n2 = c1 ;

   t = 2*e1 + b1 ;  xd[t] += n1 ;
   t = 2*e2 + b2 ;  xd[t] += n2 ;

   e1 = 0; b1=1; n1 = c2 ;
   e2 = 1; b2=0; n2 = c2 ;
   t = 2*e1 + b1 ;  xd[t] += n1 ;
   t = 2*e2 + b2 ;  xd[t] += n2 ;

   return ylike ;

}

void setinit(SNP **snpm, Indiv *indx) 

#define TINITLO 0.05
#define TINITHI 0.95
#define LINITLO 1.00
#define LINITHI 30.00

{
    int fc, lc ;  
    SNP *cupt ;
    double theta, lambda ;
    int numstates, ignore ;

     ivmaxmin(fchrom, 22, NULL, &fc) ;
     ivmaxmin(lchrom, 22, &lc, NULL) ;

     if ((fc>99999) || (lc<0) ) 
      fatalx("(setinit) nothing on chrom 1 or 22\n") ;

     cupt = snpm[fc] ;
     gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;

     vclip(&theta, &theta,  TINITLO, TINITHI,1) ;
     vclip(&lambda, &lambda,  LINITLO, LINITHI,1) ;
     puttln(cupt, indx, theta, lambda) ;

     fc = fchrom[23] ;  
     if (fc<=9999) {  
      cupt = snpm[fc] ;
      gettln(cupt, indx, &theta, &lambda, &numstates, &ignore) ;

      vclip(&theta, &theta,  TINITLO, TINITHI,1) ;
      vclip(&lambda, &lambda,  LINITLO, LINITHI,1) ;
      puttln(cupt, indx, theta, lambda) ;

     }
}
void dohetxcheck(SNP **snpm, Indiv **indivmarkers, int numsnps) 
{
   int i, j, g, n ;
   int nhet, nhz ;
   SNP *cupt ;

   printf("###HETXCHECK RESULTS BEGIN\n");
   printf("##%28s %8s %8s\n", "SNP_ID","NUM_HET","NUM_HOMOZY"); 

   for (i=0; i<numsnps; i++)  {  
    cupt = snpm[i] ;
    if (cupt -> isfake) continue ;
    if (cupt -> ignore) continue ;
    if ((cupt -> chrom) != 23) continue ;
    nhet = nhz = 0 ;
    n = cupt -> ngtypes ;
    for (j=0; j<n; j++) {  
     g = getgtypes(cupt, j) ; 
     if (g<0) continue ;
     if (indivmarkers[j] -> gender != 'M') continue ;
     if (g==1) ++nhet ;
     else ++nhz ;
    }
    printf("hetxcheck %20s %6d %8d\n", cupt -> ID, nhet, nhz) ;
   }
   printf("\n");
}

void dohwcheck (SNP ** snpm, int numsnps, int vmode) 
{
   SNP *cupt ;
   double cc[3], y ;
   double hwtot, hwnum , hwave, hwtt, hwnn ;
#define MAXCH 25
   double hwn[MAXCH+1] ;
   double hwt[MAXCH+1] ;
   int i, chrom ;

   vzero(hwt, MAXCH+1) ;
   vzero(hwn, MAXCH+1) ;
   hwtot = hwnum = 0 ;
   
   if(vmode)
     {
       printf("###HWCHECK RESULTS FOLLOW:\n");
       printf("##%25s %10s %10s %10s\n","SNP_ID","SNP_INDEX","CHR_NUM","HW_SCORE");
     }
   for (i=0; i<numsnps; i++)  {  
    cupt = snpm[i] ;

    if (cupt -> isfake) continue ;
    if (cupt -> ignore) continue ;
    chrom = cupt -> chrom ;
    if (chrom == 23) continue ; /* autosomes only */
    y = hwcheck(cupt, cc) ;
    if (asum(cc,3) == 0.0) continue ;
    if (vmode) { 
      printf("hwcheck %20s %5d %8d %12.3f\n",
	     cupt -> ID, i,chrom,y) ;
    }
    hwt[chrom] += y ;
    hwn[chrom] += 1 ;
   }

   printf("\n");
   hwnum = asum(hwn, MAXCH) ;
   hwtot = asum(hwt, MAXCH) ;

   if (hwnum < 0.1) return ;
   for (chrom =1 ; chrom <=22 ; ++chrom) {
    hwtt = hwt[chrom] ;
    hwnn = hwn[chrom] ;
    if (hwnn<0.5) continue ;
    hwave = hwtt/hwnn ;
    hwtt /= sqrt (hwnn) ; 
    printf("hwstats (chrom %2d) ave: %9.3f sigma: %9.3f\n", 
     chrom, hwave, hwtt) ;
   }
   hwtt = hwtot ;
   hwnn = hwnum ;
   hwave = hwtt/hwnn ;
   hwtt /= sqrt (hwnn) ; 
   printf("hwstats (autosomes) ave: %9.3f sigma: %9.3f\n", 
    hwave, hwtt) ;
}
void calcY(SNP **snpm, int i, int j, double *X, int numstates) 
{ 
   int t ; 
   SNP *cupt ; 
    
   cupt = snpm[j] ; 
   t = cupt -> isrfake ; 
   cupt -> isrfake = NO ; 
   calcX(snpm,  i, j, X, numstates) ; 
   cupt -> isrfake = t ; 
} 

void calcX(SNP **snpm, int i, int j, double *X, int numstates)
{
  int x,k;
  double PopA_freq, PopB_freq;
  SNP *cupt ;
  Indiv *indx ;

  if ((j>=numsnps) || (j<0)) fatalx("(calcX) bounds check failure %d\n",j) ;

  vzero(X,3) ;
  if (j == magicnum) {  
    magicgg(X, i) ;
    return ;
  }

  cupt = snpm[j] ;
  if ((cupt->ignore) || (cupt -> isrfake)) {  
   vclear(X, 1.0, numstates) ; 
   return ; 
  } 
  if (cupt -> ngtypes == 0) {   
   vclear(X, 1.0, numstates) ; 
   return ; 
  } 

  x = getgtypes(cupt, i) ;

  if (x<0) {  
   vclear(X, 1.0, numstates) ;
   return ; 
  }

  PopA_freq = cupt -> adm_PopA_freq;
  PopB_freq = cupt -> adm_PopB_freq;

  if ((PopA_freq<0) || (PopB_freq<0)) 
    fatalx("marker freqs %s not set\n", cupt -> ID) ;

  if (numstates == 3) {
    switch(x) {
      
    case 2:
      X[0] = PopA_freq * PopA_freq;
      X[1] = PopA_freq * PopB_freq;
      X[2] = PopB_freq * PopB_freq;
      break;
      
    case 1:
      X[0] = 2 * PopA_freq * (1 - PopA_freq) ;
      X[1] = PopB_freq * (1 - PopA_freq) + 
	(1 - PopB_freq) * PopA_freq ;
      X[2] =  2 * PopB_freq * (1 - PopB_freq) ;
      break;
      
    case 0:
      X[0] = (1 - PopA_freq) * (1 - PopA_freq);
      X[1] = (1 - PopA_freq) * (1 - PopB_freq);
      X[2] = (1 - PopB_freq) * (1 - PopB_freq);
      break;
  
    default:
      printf("zzzunset %d %d %d\n", i, x, j) ;
      indx = indivmarkers[i] ;
      printf(" gender: %c  chrom: %d\n", 
        indx -> gender, cupt -> chrom) ;
      fatalx(" %s %s %d %d genotype unset\n", cupt->ID, indx -> ID, i , x) ;
    }
  }
  else if (numstates == 2) {
    switch(x) {

    case 2:
      X[0] = PopA_freq;
      X[1] = PopB_freq;
      break;

    case 0:
      X[0] = (1 - PopA_freq);
      X[1] = (1 - PopB_freq);
      break;
  
    default:
      printf("zzzunset %d %d %d\n", i, x, j) ;
      indx = indivmarkers[i] ;
      printf(" gender: %c  chrom: %d\n", 
        indx -> gender, cupt -> chrom) ;
      fatalx(" %s %s %d %d genotype unset\n", cupt->ID, indx -> ID, i , x) ;
    }
  }
}

void
 putepath(SNP **snpm, int *ethnic, int fc, int lc,  int indiv) 
{
  int i, t, g ; 
  SNP *cupt ;

  for (i=fc; i<=lc; ++i) { 
   cupt = snpm[i] ;
   if (cupt -> ebuff == NULL) continue ;
   putep(cupt, indiv, ethnic[i]) ;
  }
  if (indiv > -1) return ;
  cupt = snpm[fc] ;
  t = getep(cupt, indiv) ;
  g = getgtypes(cupt, indiv) ;
  printf("zz  %d %d %s %x %d %d %d\n", indiv, fc, cupt -> ID, cupt -> ebuff, t, ethnic[fc], g) ;
}
