#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <nicklib.h>
#include <getpars.h>

#include "admutils.h"
#include "mcio.h"  
#include "mcmcpars.h"  

#define WVERSION   "1000" 
/** 
 reformats files.             
*/


#define MAXFL  50   
#define MAXSTR  512

char *trashdir = "/var/tmp" ;
int verbose = NO ;
int qtmode = NO ;
Indiv **indivmarkers;
SNP **snpmarkers ;
int numsnps, numindivs ; 

char  *genotypename = NULL ;
char  *snpname = NULL ;
char *indoutfilename = NULL ;
char *snpoutfilename = NULL ;
char  *genooutfilename = NULL ;
char  *indivname = NULL ;
char *badsnpname = NULL ;

int packout = NO ;
extern enum outputmodetype outputmode  ;
char *omode = NULL ;
extern int packmode ;



char  unknowngender = 'U' ;

void setomode(enum outputmodetype *outmode, char *omode)  ;
void readcommands(int argc, char **argv) ;
void outfiles(char *snpname, char *indname, char *gname, SNP **snpm, 
  Indiv **indiv, int numsnps, int numind, int packem) ;

int main(int argc, char **argv)
{

  int **snppos ;
  int *snpindx ;
  char **snpnamelist, **indnamelist ;
  char **eglist ;
  int  lsnplist, lindlist, numeg ;
  int i,j; 
  SNP *cupt, *cupt1, *cupt2, *cupt3 ;
  Indiv *indx ;
  double gpos1,gpos2,cpos1,cpos2,gd, cd, gd100 ;
  double rthresh, zt ;
  int mpflag ;

  int ch1, ch2 ;
  int fmnum , lmnum ;
  int num, n1, n2 ;

  int nindiv = 0, e, f, lag=1  ;
  double xc[9], xd[4], xc2[9] ;
  double ychi, zscore, zthresh = 20.0 ;
  int nignore, numrisks = 1 ;

  readcommands(argc, argv) ;

  setomode(&outputmode, omode) ;
  packmode = YES ;

  numsnps = 
    getsnps(snpname, &snpmarkers, 0.0, badsnpname, &nignore, numrisks) ;

  numindivs = getindivs(indivname, &indivmarkers) ;
  setgenotypename(&genotypename, indivname) ;
  setstatus(indivmarkers, numindivs, "Case") ;

  getgenos(genotypename, snpmarkers, indivmarkers, 
    numsnps, numindivs, nignore) ;

  settersemode(YES) ;

  outfiles(snpoutfilename, indoutfilename, genooutfilename, 
   snpmarkers, indivmarkers, numsnps, numindivs, packout) ;

  printf("##end of run\n") ;
  return 0 ;
}
void readcommands(int argc, char **argv) 

{
  int i,haploid=0;
  char *parname = NULL ;
  phandle *ph ;
  char str[5000]  ;
  char *tempname ;
  int n ;

  while ((i = getopt (argc, argv, "p:vV")) != -1) {

    switch (i)
      {

      case 'p':
	parname = strdup(optarg) ;
	break;

      case 'v':
	printf("version: %s\n", WVERSION) ; 
	break; 

      case 'V':
	verbose = YES ;
	break; 

      case '?':
	printf ("Usage: bad params.... \n") ;
	fatalx("bad params\n") ;
      }
  }

         
   pcheck(parname,'p') ;
   printf("parameter file: %s\n", parname) ;
   ph = openpars(parname) ;
   dostrsub(ph) ;

/**
DIR2:  /fg/nfiles/admixdata/ms2
SSSS:  DIR2/outfiles 
genotypename: DIR2/autos_ccshad_fakes
eglistname:    DIR2/eurlist  
output:        eurout
*/
   getstring(ph, "genotypename:", &genotypename) ;
   getstring(ph, "snpname:", &snpname) ;
   getstring(ph, "indivname:", &indivname) ;
   getstring(ph, "badsnpname:", &badsnpname) ;
   getstring(ph, "indoutfilename:", &indoutfilename) ;
   getstring(ph, "snpoutfilename:", &snpoutfilename) ;
   getstring(ph, "genooutfilename:", &genooutfilename) ;
   getstring(ph, "outputmode:", &omode) ;

   getint(ph, "packout:", &packout) ;
   writepars(ph) ;
   closepars(ph) ;

}

void setomode(enum outputmodetype *outmode, char *omode) 
{
 char *ss ;
 int len, i ;
 if (outmode == NULL) return ; 
 *outmode = ANCESTRYMAP ;
 if (omode == NULL) return ;

 ss = strdup(omode) ;
 len = strlen(ss) ;
 for (i=0; i<len ; i++) {
  ss[i] = tolower(ss[i]) ;
 }

 if (strcmp(ss, "alkes") == 0)  *outmode = ALKES ;
 if (strcmp(ss, "ped") == 0)  *outmode = PED ;
 if (strcmp(ss, "packedped") == 0)  *outmode = PACKEDPED ;

 free(ss) ;
}




