#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <nicklib.h>
#include <getpars.h>

#include "badpairs.h"
#include "admutils.h"
#include "mcio.h"  
#include "mcmcpars.h"  

#define WVERSION   "200" 

// badpairsname added 
/** 
 does nothing but read the data 
 and print snps
 sometimes a good place to start !!
*/


#define MAXFL  50   
#define MAXSTR  512

extern int packmode ;

char *trashdir = "/var/tmp" ;
int verbose = NO ;
int qtmode = NO ;
Indiv **indivmarkers;
SNP **snpmarkers ;
int numsnps, numindivs ; 

char  *genotypename = NULL ;
char  *snpname = NULL ;
char  *genooutfilename = NULL ;
char  *indoutfilename = NULL ;
char  *indivname = NULL ;
char *badsnpname = NULL ;
char *goodsnpname = NULL ;
char *badpairsname = NULL ;
char *printsnpname  = NULL ;

char *outputname = NULL ;
FILE *ofile ;


char  unknowngender = 'U' ;

void readcommands(int argc, char **argv) ;

int main(int argc, char **argv)
{

  int **snppos ;
  int *snpindx ;
  char **snpnamelist, **indnamelist ;
  char **eglist ;
  int  lsnplist, lindlist, numeg ;
  int i,j; 
  SNP *cupt, *cupt1, *cupt2, *cupt3 ;
  Indiv *indx ;
  double gpos1,gpos2,cpos1,cpos2,gd, cd, gd100 ;
  double rthresh, zt ;
  int numvind  ;

  int ch1, ch2 ;
  int fmnum , lmnum ;
  int num, n1, n2 ;

  int nindiv = 0, e, f, lag=1  ;
  int nignore, numrisks = 1, knum, k ;

  ofile = stdout; 
  packmode = NO ;
  readcommands(argc, argv) ;
  if (outputname != NULL) openit(outputname, &ofile, "w") ;

  numsnps = 
    getsnps(snpname, &snpmarkers, 0.0, badsnpname, &nignore, numrisks) ;

  numindivs = getindivs(indivname, &indivmarkers) ;
  setstatus(indivmarkers, numindivs, "Case") ;

  getgenos(genotypename, snpmarkers, indivmarkers, 
    numsnps, numindivs, nignore) ;

  if (badpairsname != NULL) {
    loadbadpsc(snpmarkers, numsnps, NO, goodsnpname) ;
    dobadpairs(badpairsname, snpmarkers, numsnps) ;
  }

  if (printsnpname == NULL) fatalx("printsnpname compulsory\n") ;
  knum = snpindex(snpmarkers, numsnps, printsnpname) ;
  cupt = snpmarkers[knum] ;

  printf("## snp: %s\n", printsnpname) ;
  for (k=0; k<numindivs; ++k) {  
   indx = indivmarkers[k] ;
   printf("%20s ", indx->ID) ;  
   printf("%c ", indx -> gender) ; 
   printf("%10s ", indx -> egroup) ;
   printf("%3d\n" , getgtypes(cupt, k) ) ;
  }

  return 0 ;
}
void readcommands(int argc, char **argv) 

{
  int i,haploid=0;
  char *parname = NULL ;
  phandle *ph ;
  char str[5000]  ;
  char *tempname ;
  int n ;

  while ((i = getopt (argc, argv, "p:vV")) != -1) {

    switch (i)
      {

      case 'p':
	parname = strdup(optarg) ;
	break;

      case 'v':
	printf("version: %s\n", WVERSION) ; 
	break; 

      case 'V':
	verbose = YES ;
	break; 

      case '?':
	printf ("Usage: bad params.... \n") ;
	fatalx("bad params\n") ;
      }
  }

         
   pcheck(parname,'p') ;
   printf("parameter file: %s\n", parname) ;
   ph = openpars(parname) ;
   dostrsub(ph) ;

/**
DIR2:  /fg/nfiles/admixdata/ms2
SSSS:  DIR2/outfiles 
genotypename: DIR2/autos_ccshad_fakes
eglistname:    DIR2/eurlist  
output:        eurout
*/
   getint(ph, "packmode:", &packmode) ; // controls internals 

   getstring(ph, "genotypename:", &genotypename) ;
   getstring(ph, "genooutfilename:", &genooutfilename) ;
   getstring(ph, "indoutfilename:", &indoutfilename) ;
   getstring(ph, "snpname:", &snpname) ;
   getstring(ph, "indivname:", &indivname) ;
   getstring(ph, "output:", &outputname) ;
   getstring(ph, "badsnpname:", &badsnpname) ;
   getstring(ph, "goodsnpname:", &goodsnpname) ;
   getstring(ph, "badpairsname:", &badpairsname) ;                 
   getstring(ph, "printsnpname:", &printsnpname) ;                 

   writepars(ph) ;
   closepars(ph) ;

}

